
//================================================================
//ݒl
//Texture
sampler sampler0_ : register(s0);

//--------------------------------
//䂪ݐpp[^
static const float RENDER_WIDTH = 1024; //_OeNX`̕
static const float RENDER_HEIGHT = 1024; //_OeNX`̍

float frame_; //t[
float enemyX_; //G̈ʒuX
float enemyY_; //G̈ʒuY
float waveRadius_; //GtFNg̔a


//================================================================
//--------------------------------
//sNZVF[_͒l
struct PS_INPUT
{
	float4 diffuse : COLOR0;  //fBt[YF
	float2 texCoord : TEXCOORD0; //eNX`W
	float2 vPos : VPOS; //`W
};

//--------------------------------
//sNZVF[_o͒l
struct PS_OUTPUT
{
    float4 color : COLOR0; //o͐F
};


//================================================================
// VF[_
//--------------------------------
//sNZVF[_
PS_OUTPUT PsWave( PS_INPUT In ) : COLOR0
{
	PS_OUTPUT Out;

	//--------------------------------
	//炬vZ
	float dist2 = pow(In.vPos.x-enemyX_ ,2) + pow(In.vPos.y-enemyY_ ,2);
	float dist = sqrt(dist2);
	float sinTheta = (In.vPos.y - enemyY_) / dist;
	float cosTheta = (In.vPos.x - enemyX_) / dist;

	//cݍ쐬psinɎgppxp[^
	float angle = In.vPos.y - enemyY_ + In.vPos.x - enemyX_ + frame_;
	angle = radians(angle);

	//YsNZ̘c݂̔avZ
	//GtFNga1/16ő̘cݕƂ
	float waveRadius = waveRadius_ + waveRadius_/16 * (-1 + sin(angle));

	//S狗قǉe
	float powerRatio = (waveRadius - dist) / waveRadius;
	if(powerRatio < 0){powerRatio = 0;}

	//F擾ʒũoCAXl
	float biasRadius = waveRadius * powerRatio;
	float biasX = biasRadius * cosTheta;
	float biasY = biasRadius * sinTheta;

	//eNX`̐F擾ʒu
	float2 texUV;
	texUV.x = -biasX / RENDER_WIDTH + In.texCoord.x;
	texUV.y = -biasY / RENDER_HEIGHT + In.texCoord.y;


	//--------------------------------
	//eNX`̐F
	float4 colorTexture = tex2D(sampler0_, texUV);

	//_fBt[YF
	float4 colorDiffuse = In.diffuse;

	//
	float4 color = colorTexture * colorDiffuse;

	//FԂۂω
	if(powerRatio > 0)
	{
		color.g = color.g * (0.9 - powerRatio);
		color.b = color.b * (0.9 - powerRatio);
		color.r = color.r * (0.9 - powerRatio);
	}

	Out.color = color;

	return Out;
}


//================================================================
//--------------------------------
//technique
technique TecWave
{
	pass P0
	{
		PixelShader = compile ps_3_0 PsWave();
	}
}

